#include <stdio.h>
#include <ctype.h>
#include <EZ.h>

#ifndef DATADIR
#define DATADIR "/usr/games/lib/xdesky"
#endif

#define MAXFILENAME 200

#define LEVELFILE ".xdesky.level"

#define NAHORU   1
#define DOLU     2
#define DOPRAVA  3
#define DOLEVA   4

#define PIXELX  25
#define PIXELY  15
#define SKLON   10
#define PROSTOR 30
#define PANAKX   7
#define PANAKY -20
#define STRANA  25


#define VYTVOR   1
#define POSUN    2
#define VYMAZ    3

#define LODH     0
#define LODV     1
#define SPECIAL  2
#define OSTROV   3
#define SUPERLOD 4

#define PANAK    1
#define KONEC    2
#define LOD      4
#define TELEPORT 5


#define MAXDESKA 50


EZ_Timer *timer;

Cursor cc;

EZ_Widget *Whlavni, *Wpanacek, *Wostrov, *Wplocha, 
          *RamTlacitek1, *RamTlacitek2, *Restart,
          *Konec, *Tnastaveni, *Onastaveni, *Zavreni, *Napisy, *Pohled,
          *Tanimace, *Napoveda, *RolWidget, *Tnapoveda, *LevelNapis, *Minus, 
          *Plus, *VTahy, *Tahy, *WMaxtahy, *Wlevely, *HLodV, *HLodH, *HBostrov, 
          *Wostrov, *HSuperLod, *HVoda, *PLodV, *PLodH, *PBostrov, 
          *PSuperLod, *PVoda, *WBlik, *TUndo;

EZ_LabelPixmap *pic_panak, *pic_lod[2], *bostrov, *dira, *modre, *zlute, 
               *ikona, *pozadi, *doleva, *nahoru, *doprava, *dolu, *cerveno;

void CoDelatPriKlavese (EZ_Widget *widget, void *data, int etype, XEvent *xeve);
void nactilevel ();
void kreslipanaka (int jak);
void Restartuj();
void Dostan(EZ_Widget *widget, int doX, int doY);
void Vyres(EZ_Widget *widget);

int xmax, ymax, levelmax;
int px, py, zX, zY, kuX, kuY, meziX, meziY, minx, miny;
int konec, ostrov, edit, level, kolikrat, pocetnapoved, tolikrat, smer, animace,
pocettahu, vicetah, disminus, displus;
int teleport[4];
int pixelx, pixely, sklon, panakx, panaky, maxtahu;  

struct lod {
  int x, y;
  char typ;
  EZ_Widget * w;
} ;
struct lod * deska [MAXDESKA][MAXDESKA];
struct lod *nic, *voda, *cil;

struct undo {
  int smer[30];
  struct undo *vagon;
} ;
struct undo *vagon;
struct undo *posvagon;

char fnbuffer[MAXFILENAME];
char datadir[MAXFILENAME];

void posunlod (struct lod * l, int kam);

char * filename (char *fname)
/***************************/
     /* spoji adresar a soubor */
{
   sprintf (fnbuffer, "%s/%s", datadir, fname);
   return fnbuffer;
}

void error (char *s) 
/*******************/
     /* napise chybu a ukonci program */
{
  fprintf (stderr, "%s\n", s);
  exit (2);
}

void Undo()
/***********/
     /* vrati tah */
{
  char nazev[MAXFILENAME];
  int i, /* j, */  x, y;
  struct undo *neco /*, *p */ ;

  if(timer != NULL)return;

  if(posvagon == vagon && vagon -> smer[1] == -1) EZ_DisableWidget(TUndo);

  if(posvagon -> smer[0] == -1)
  {
    if(posvagon == vagon) return;

    neco = vagon;

    while(neco -> vagon != posvagon)  neco = neco -> vagon; 

    /* printf("pamet ubyva"); */
    free(posvagon);
    neco -> vagon = NULL;

    posvagon = neco;
  }
  else neco = posvagon;

  i=29;

  while(neco -> smer[i] == -1) i--;

  pocettahu--;
  if(pocettahu%10 == 0 || pocettahu%10 > 4) sprintf (nazev, "%d tahu", pocettahu);
  if(pocettahu%10 > 0 && pocettahu%10 < 5) sprintf (nazev, "%d tahy", pocettahu);
  if(pocettahu%10 == 1) sprintf (nazev, "%d tah", pocettahu);
  if(pocettahu%100 > 10 && pocettahu%100 < 20) sprintf (nazev, "%d tahu", pocettahu);
  EZ_ConfigureWidget (Tahy, EZ_LABEL_STRING, nazev, 0);

  if(neco -> smer[i] > 3)
  {
    if(neco -> smer[i] == 4)
    {
      py = py+1; 
      posunlod(deska [px][py], DOLU);
    }
    if(neco -> smer[i] == 5)
    {
      py = py-1; 
      posunlod(deska [px][py], NAHORU);
    }
    if(neco -> smer[i] == 6)
    {
      px = px+1;
      posunlod(deska [px][py], DOPRAVA);
    }
    if(neco -> smer[i] == 7)
    {
      px = px-1;
      posunlod(deska [px][py], DOLEVA);
    }

    neco -> smer[i] = -1;

    /* printf("px-%d, py-%d,\n\nsmer-%d, i-%d\n\n", px, py, neco -> smer[i], i); */
    /*
    while (p) {
      for (j=0; j<30; j++) printf ("%d ",p->smer[j]); 
      printf ("\n");
      p = p->vagon;
    }
    */
    animace++;
    Dostan(deska [px][py]->w,px*pixelx + py*sklon,
			     py*pixely + PROSTOR);
    animace--;
    return;
  }
  if(deska [px][py] -> typ == SUPERLOD)
  {
    if(deska [deska [px][py] -> x][deska [px][py] -> y] == voda)
    {
      /* printf("px = %d, py = %d, tele X = %d, tele Y = %d\n", px, py, deska [px][py] -> x, deska [px][py] -> y); */

      x = px;
      y = py;

      px = deska [x][y] -> x;
      py = deska [x][y] -> y;

      deska [px] [py] = deska [x][y];
      deska [px] [py] -> x = x;
      deska [px] [py] -> y = y;

      /* printf("px = %d, py = %d, tele X = %d, tele Y = %d\n", px, py, deska [px][py] -> x, deska [px][py] -> y); */

      vicetah = neco -> smer[i];
      neco -> smer[i] = -1;

      animace++;      

      /* printf("%d",EZ_GetWidgetIntData(deska [px][py]->w)); */

      Dostan(deska [x][y]->w,px*pixelx + py*sklon,
			     py*pixely + PROSTOR);
      deska [x][y] = voda;

      /* printf("%d",EZ_GetWidgetIntData(deska [px][py]->w)); */

      animace--;

      return;
    }
  }
  if(neco -> smer[i] == 0){py = py+1;}
  if(neco -> smer[i] == 1){py = py-1;}
  if(neco -> smer[i] == 2){px = px+1;}
  if(neco -> smer[i] == 3){px = px-1;}

  neco -> smer[i] = -1;

  /* printf("px-%d, py-%d,\n\n smer-%d, i-%d\n \n", px, py, neco -> smer[i], i); */
  /*
  while (p) {
    for (j=0; j<30; j++)  printf ("%d ",p->smer[j]); 
    printf ("\n");
    p = p->vagon;
  }
  */
  
  vicetah = -2;

  animace++;

  Dostan( Wpanacek, px*pixelx + py*sklon + panakx,
	  py*pixely + PROSTOR + panaky);
  animace--;
}
void UlozInfo(int kudy)
/**********************/
     /* ulozi tah */
{
  int i /* ,j */;
  /* struct undo *p; */

  EZ_EnableWidget(TUndo);

  if(posvagon -> smer[29] >= 0)
  {

    /* printf("pamet pribyva %d\n", sizeof(struct undo)); */
    posvagon = posvagon->vagon = malloc(sizeof(struct undo));
    for(i=0;i<=29;i++)
    {
      posvagon -> smer[i] = -1;
    }
    posvagon -> vagon = NULL;
  }
  i=0;
  while(posvagon->smer[i] >= 0)
  {
    i++;
  }
  
  posvagon->smer[i] = kudy;

  /* printf ("po:   "); 
  p=vagon;   
  while (p) {
    for (j=0; j<30; j++) printf ("%d ",p->smer[j]); 
    printf ("\n");
    p = p->vagon;
  }
  */
}

void Konci()
/**********/
     /* ukonci program */
{
  printf("At se mate krasne az budete viset nad propasti.\n");
  EZ_Shutdown();
  exit (1);
}

void Zavrit ()
/************/
     /* zavre napovedu */
{
  pocetnapoved = 0;
  EZ_EnableWidget(Tnapoveda);
  EZ_DestroyWidget(Napoveda);
}

void LevelPlus()
/**************/
     /* jde na dalsi level */
{
  if(displus)return;

  level++;
  if(level>=levelmax && levelmax>0){ EZ_DisableWidget(Plus), displus = 1; }
  EZ_EnableWidget(Minus);
  disminus=0;
  Restartuj();
}

void LevelMinus()
/***************/
     /* vrati se na predchozi level */
{
  if(disminus)return;

  level--;
  if(level<=0) level=-levelmax;
  if(level<=1 && levelmax>0){ EZ_DisableWidget(Minus); disminus=1; }
  EZ_EnableWidget(Plus);
  displus=0;
  Restartuj();
}
void VyresTahy()
/***************/
     /* prida tah */
{
  char nazev[MAXFILENAME];

  pocettahu++;
  if(pocettahu%10 == 0 || pocettahu%10 > 4) sprintf (nazev, "%d tahu", pocettahu);
  if(pocettahu%10 > 0 && pocettahu%10 < 5) sprintf (nazev, "%d tahy", pocettahu);
  if(pocettahu%10 == 1) sprintf (nazev, "%d tah", pocettahu);
  if(pocettahu%100 > 10 && pocettahu%100 < 20) sprintf (nazev, "%d tahu", pocettahu);
  EZ_ConfigureWidget (Tahy, EZ_LABEL_STRING, nazev, 0);
}
void Napovez()
/************/
     /* otevre napovedu */
{
  int pos;
  char mezery[] = "                                            ";

  if(pocetnapoved>0) return;
  EZ_DisableWidget(Tnapoveda);
  pocetnapoved++;

  Napoveda = EZ_CreateWidget(EZ_WIDGET_FRAME, NULL,
			     EZ_WIDTH, 600,
			     EZ_HEIGHT, 420,
			     EZ_PADX, 0,
			     EZ_PADY, 0,
			     EZ_WM_WINDOW_NAME, "XDesky - Napoveda",
			     EZ_ORIENTATION, EZ_VERTICAL,
			     EZ_WMHINTS,PMinSize|PMaxSize|PWinGravity,
			     EZ_WM_ICON_PIXMAP, ikona,
			     0); 
  Zavreni = EZ_CreateWidget(EZ_WIDGET_NORMAL_BUTTON, Napoveda,
			    EZ_WIDTH, 100,		
			    EZ_LABEL_STRING, "Zavrit",
			    EZ_CALLBACK,  Zavrit, NULL,	
			    EZ_BACKGROUND, "grey74",    
			    EZ_BORDER_WIDTH, 3,
			    EZ_UNDERLINE, 0,
			    0);  
  RolWidget = EZ_CreateWidget(EZ_WIDGET_TEXT, Napoveda,
			      EZ_WIDTH, 588,
			      EZ_HEIGHT, 380,
			      EZ_PADX, 0,
			      EZ_PADY, 0,
			      EZ_TEXT_WIDGET_EDITABLE, 0,
			      EZ_FONT_NAME, "*fixed*2",
			      EZ_OPTIONAL_HSCROLLBAR, 0,
			      0); 
  EZ_TextLoadFile(RolWidget, filename("napoveda"));

  /* EZ knihovna chybne zobrazuje konce radku, coz je nehezke,
     musime posunout konce radku mimo okno */

  EZ_TextEndOfBuffer (RolWidget);
  pos = 0;
  while (1) {
    EZ_TextEndOfLine (RolWidget);
    EZ_TextInsertString (RolWidget, mezery);
    EZ_TextInsertString (RolWidget, mezery);
    EZ_TextBeginningOfLine (RolWidget);
    if (pos) break;
    EZ_TextPreviousLine (RolWidget);
    if (EZ_TextGetPosition (RolWidget) == 0) pos = 1;
  }
  EZ_DisplayWidget(Napoveda);
}

void Restartuj()
/***************/
     /* nacte znovu ten samy level */
{
  int i,j;
  struct undo *neco, *dal;
 
  EZ_DisableWidget(TUndo);
 
  neco=vagon->vagon;
  while(neco != NULL)
  {
    dal = neco -> vagon;
    free(neco);
    neco = dal;
  }
  posvagon = vagon;

  for(i=0;i<=29;i++)
  {
   vagon->smer[i] = -1;
  }

  vagon->vagon = NULL;

  edit=0;
  if(timer!=NULL){ 
    EZ_CancelTimer(timer);
    timer=NULL;
  }
  
    i=j=0;
    while(j>ymax){
      if(deska[i][j]->typ == '<' || deska[i][j]->typ == '^' || deska[i][j]->typ == 'o'){
        free(deska[i][j]);
      }
      i++;
      if(i>xmax){i=0; j++;}
    }
   
  EZ_DestroyWidget(Wplocha); 
  Wplocha = EZ_CreateWidget(EZ_WIDGET_FRAME, Whlavni,
			    EZ_WIDTH, 610,
			    EZ_HEIGHT, 600,
			    EZ_PROPAGATE, 1,
			    EZ_PADX, 0,
			    EZ_PADY, 0,
			    EZ_BG_PIXMAP, pozadi,
			    EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			    0);
  px=0;
  py=0;
  nactilevel();
  kreslipanaka (VYTVOR);      
}
void Animace()
/************/
     /* prohodi animaci */
{
  if(animace == 1){
    EZ_ConfigureWidget(Tanimace, EZ_LABEL_STRING, "Vypni Animaci", 0);
    animace = 0;
    return;
  }
  if(animace == 0){
    EZ_ConfigureWidget(Tanimace, EZ_LABEL_STRING, "Zapni Animaci", 0);
    animace = 1;
    return;
  }
}

void ZmenPohled()
/***************/
     /* zmeni pohled a restartuje level */
{
 if(smer==0){
    smer=1;

    pixelx = STRANA;
    pixely = STRANA;
    sklon = 0;
    panakx = 0;
    panaky = 0;

    pic_panak = EZ_CreateLabelPixmapFromXpmFile(filename("zhfigurka.xpm"));
    pic_lod[0] = EZ_CreateLabelPixmapFromXpmFile(filename("zhdeska2.xpm"));
    pic_lod[1] = EZ_CreateLabelPixmapFromXpmFile(filename("zhdeska.xpm"));

    if(pic_panak == NULL || pic_lod[0] == NULL || pic_lod[1] == NULL || dira == NULL || modre == NULL || zlute == NULL || bostrov == NULL)
    {      
      fprintf (stderr, "nejdou precist data z adresare %s\n", datadir);
      pic_panak = EZ_CreateLabelPixmapFromXpmFile(filename("zfigurka.xpm"));
      pic_lod[0] = EZ_CreateLabelPixmapFromXpmFile(filename("deska.xpm"));
      pic_lod[1] = EZ_CreateLabelPixmapFromXpmFile(filename("deska2.xpm"));
      smer=0;
      return;
    }
    Restartuj();
    return;
  }

  if(smer==1){
    smer=0;
    pixelx = PIXELX;
    pixely = PIXELY;
    sklon = SKLON;
    panakx = PANAKX;
    panaky = PANAKY;

    pic_panak = EZ_CreateLabelPixmapFromXpmFile(filename("zfigurka.xpm"));
    pic_lod[0] = EZ_CreateLabelPixmapFromXpmFile(filename("deska.xpm"));
    pic_lod[1] = EZ_CreateLabelPixmapFromXpmFile(filename("deska2.xpm"));
    dira = EZ_CreateLabelPixmapFromXpmFile(filename("dira.xpm"));
    modre = EZ_CreateLabelPixmapFromXpmFile(filename("modre.xpm"));
    zlute = EZ_CreateLabelPixmapFromXpmFile(filename("zlute.xpm"));
    bostrov = EZ_CreateLabelPixmapFromXpmFile(filename("ostrov.xpm"));
    if(pic_panak == NULL || pic_lod[0] == NULL || pic_lod[1] == NULL || dira == NULL || modre == NULL || zlute == NULL || bostrov == NULL)
    {      
      fprintf (stderr, "nejdou precist data z adresare %s\n", datadir);
      pic_panak = EZ_CreateLabelPixmapFromXpmFile(filename("zfigurka.xpm"));
      pic_lod[0] = EZ_CreateLabelPixmapFromXpmFile(filename("deska.xpm"));
      pic_lod[1] = EZ_CreateLabelPixmapFromXpmFile(filename("deska2.xpm"));   
      smer=1;
      return;
    }

    Restartuj();
  }
}

void Nastav () 
/***********/
     /* nepouzita funkce */
{
  if(pocetnapoved > 0) return;
  pocetnapoved = 1;

  Onastaveni = EZ_CreateWidget(EZ_WIDGET_FRAME, NULL,
			       EZ_WIDTH, 128,
			       EZ_HEIGHT, 300,
			       EZ_PADX, 0,
			       EZ_PADY, 0,
			       EZ_ORIENTATION, EZ_VERTICAL,
			       EZ_WMHINTS,PMinSize|PMaxSize|PWinGravity,
			       EZ_WM_ICON_PIXMAP, ikona,
			       0);
  
  Zavreni = EZ_CreateWidget(EZ_WIDGET_NORMAL_BUTTON, Onastaveni,
			    EZ_WIDTH, 128,	
			    EZ_X, 0,
			    EZ_Y, 0,
			    EZ_LABEL_STRING, "Zavrit",
			    EZ_CALLBACK,  Zavrit, NULL,
			    EZ_BACKGROUND, "white",  
			    EZ_BORDER_WIDTH, 1,
			    EZ_UNDERLINE, 1,
			    0);  
  
  Napisy = EZ_CreateWidget(EZ_WIDGET_FRAME, Onastaveni,
			   EZ_LABEL_STRING, "Animace",
			   EZ_BORDER_WIDTH, 0,
			   EZ_UNDERLINE, 1,
			   0);
 
  EZ_DisplayWidget(Onastaveni);
}

void inicializujplochu () 
/***********************/
     /* vyrobi tlacitka a pozadi */
{
  int i;
  FILE* file;
  
  posvagon = vagon = malloc(sizeof(struct undo));

  for(i=0;i<=29;i++)
  {
   vagon->smer[i] = -1;
  }

  vagon->vagon = NULL;

  sprintf (fnbuffer, "%s/%s", getenv("HOME"), LEVELFILE);
  file = fopen (fnbuffer, "r");
  if(file==NULL) levelmax = 1;
  else { 
    fread(&levelmax, sizeof(int), 1, file);
    fclose(file);
  }
  if(level < 1 || level > levelmax) level=levelmax;

  WBlik = NULL;
  cerveno = EZ_CreateLabelPixmapFromXpmFile(filename("blik.xpm"));

  if(smer == 0){
    pixelx = PIXELX;
    pixely = PIXELY;
    sklon = SKLON;
    panakx = PANAKX;
    panaky = PANAKY;

    pic_panak = EZ_CreateLabelPixmapFromXpmFile(filename("zfigurka.xpm"));
    pic_lod[0] = EZ_CreateLabelPixmapFromXpmFile(filename("deska.xpm"));
    pic_lod[1] = EZ_CreateLabelPixmapFromXpmFile(filename("deska2.xpm"));
    dira = EZ_CreateLabelPixmapFromXpmFile(filename("dira.xpm"));
    modre = EZ_CreateLabelPixmapFromXpmFile(filename("modre.xpm"));
    zlute = EZ_CreateLabelPixmapFromXpmFile(filename("zlute.xpm"));
    bostrov = EZ_CreateLabelPixmapFromXpmFile(filename("ostrov.xpm"));
    
    if(pic_panak == NULL || pic_lod[0] == NULL || pic_lod[1] == NULL || dira == NULL || modre == NULL || zlute == NULL || bostrov == NULL)
    {      
      fprintf (stderr, "nejdou precist data z adresare %s\n\
provedte nejprve make install nebo pouzijte parametr -d /adresar/s/daty.\n", 
      datadir);
      exit(1);
    }
  }
  else
  {
    pixelx = STRANA;
    pixely = STRANA;
    sklon = 0;
    panakx = 0;
    panaky = 0;
    pic_panak = EZ_CreateLabelPixmapFromXpmFile(filename("zhfigurka.xpm"));
    pic_lod[0] = EZ_CreateLabelPixmapFromXpmFile(filename("zhdeska2.xpm"));
    pic_lod[1] = EZ_CreateLabelPixmapFromXpmFile(filename("zhdeska.xpm"));

    if(pic_panak == NULL || pic_lod[0] == NULL || pic_lod[1] == NULL)
    {
      fprintf (stderr, "nejdou precist data z adresare %s\n\
provedte nejprve make install nebo pouzijte parametr -d /adresar/s/daty.\n", 
      datadir);
      exit(1);
    }
  }
  ikona = EZ_CreateLabelPixmapFromXpmFile(filename("ikona.xpm"));
  pozadi= EZ_CreateLabelPixmapFromXpmFile(filename("patern.xpm"));

  cc = EZ_CreateCursorFromBitmapFile 
     (filename("mys.xbm"), NULL, "red", NULL, 15, 15, "otes", 0);

  Whlavni = EZ_CreateWidget(EZ_WIDGET_FRAME, NULL,
			    EZ_WIDTH, 610,
			    EZ_HEIGHT, 540,
			    EZ_PADX, 0,
			    EZ_PADY, 0,
			    EZ_BG_PIXMAP, pozadi,
			    EZ_WM_WINDOW_NAME, "XDesky - Hlavni Okno",
			    EZ_ORIENTATION, EZ_VERTICAL,
			    EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			    EZ_WM_ICON_PIXMAP, ikona,
			    0); 
  RamTlacitek1 = EZ_CreateWidget(EZ_WIDGET_FRAME, Whlavni,
				EZ_WIDTH, 610,
				EZ_HEIGHT, 40,
				EZ_PADX, 0,
				EZ_PADY, 0,
				EZ_BACKGROUND, "DarkSlateGray",
				EZ_ORIENTATION, EZ_HORIZONTAL,
			        EZ_WMHINTS,PMinSize|PMaxSize|PWinGravity,
				EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
				0); 

  Tanimace = EZ_CreateWidget(EZ_WIDGET_NORMAL_BUTTON, RamTlacitek1,
			     EZ_WIDTH, 100,		
			     EZ_LABEL_STRING, "Zapni Animaci",
			     EZ_CALLBACK,  Animace, NULL,
			     EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			     EZ_BACKGROUND, "grey74",    
			     EZ_BORDER_WIDTH, 3,
			     EZ_UNDERLINE, 6,
			     0);  

  Restart = EZ_CreateWidget(EZ_WIDGET_NORMAL_BUTTON, RamTlacitek1,
			    EZ_WIDTH, 100,		
			    EZ_LABEL_STRING, "Restart",
			    EZ_CALLBACK,  Restartuj, NULL,
			    EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			    EZ_BACKGROUND, "grey74",    
			    EZ_BORDER_WIDTH, 3,
			    EZ_UNDERLINE, 0,
			    0);  

  Konec = EZ_CreateWidget(EZ_WIDGET_NORMAL_BUTTON, RamTlacitek1,
			  EZ_WIDTH, 100,		
			  EZ_LABEL_STRING, "KONEC!",
			  EZ_CALLBACK,  Konci, NULL,
			  EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			  EZ_BACKGROUND, "grey74",    
			  EZ_BORDER_WIDTH, 3,
			  0);
  Pohled = EZ_CreateWidget(EZ_WIDGET_NORMAL_BUTTON, RamTlacitek1,
			   EZ_WIDTH, 100,		
			   EZ_LABEL_STRING, "Zmen pohled",
			   EZ_CALLBACK,  ZmenPohled, NULL,
			   EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			   EZ_BACKGROUND, "grey74",    
			   EZ_BORDER_WIDTH, 3,
			   EZ_UNDERLINE, 0,
			   0);
  Tnapoveda = EZ_CreateWidget(EZ_WIDGET_NORMAL_BUTTON, RamTlacitek1,
			      EZ_WIDTH, 100,		
			      EZ_LABEL_STRING, "Napoveda",
			      EZ_CALLBACK,  Napovez, NULL,
			      EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			      EZ_BACKGROUND, "grey74",    
			      EZ_BORDER_WIDTH, 3,
			      EZ_UNDERLINE, 0,
			      0);
  RamTlacitek2 = EZ_CreateWidget(EZ_WIDGET_FRAME, Whlavni,
				 EZ_WIDTH, 610,
				 EZ_HEIGHT, 30,
				 EZ_PADX, 0,
				 EZ_PADY, 0,
				 EZ_BACKGROUND, "DarkSlateGray",
				 EZ_ORIENTATION, EZ_HORIZONTAL,
				 EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
				 0);

  Wlevely = EZ_CreateWidget(EZ_WIDGET_FRAME, RamTlacitek2,
				 EZ_WIDTH, 150,
				 EZ_HEIGHT, 30,
				 EZ_PADX, 0,
				 EZ_PADY, 0,
				 EZ_BACKGROUND, "DarkSlateGray",
				 EZ_ORIENTATION, EZ_HORIZONTAL,
				 EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
				 0);
  VTahy = EZ_CreateWidget(EZ_WIDGET_FRAME, RamTlacitek2,
			  EZ_WIDTH, 300,
			  EZ_HEIGHT, 30,
			  EZ_PADX, 0,
			  EZ_PADY, 0,
			  EZ_BACKGROUND, "DarkSlateGray",
			  EZ_ORIENTATION, EZ_HORIZONTAL,
			  EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			  0);

  Minus = EZ_CreateWidget(EZ_WIDGET_NORMAL_BUTTON, Wlevely,
			  EZ_WIDTH, 20,
			  EZ_HEIGHT, 20,
			  EZ_LABEL_STRING, "-",
			  EZ_CALLBACK,  LevelMinus, NULL,
			  EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			  EZ_BACKGROUND, "grey74",    
			  EZ_BORDER_WIDTH, 3,
			  0);  
  if(level==1){ EZ_DisableWidget(Minus); disminus=1; }

  LevelNapis =  EZ_CreateWidget(EZ_WIDGET_LABEL, Wlevely,
				EZ_FOREGROUND, "white",
				EZ_LABEL_STRING, "Level: 0",
				EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
				0);

  Plus = EZ_CreateWidget(EZ_WIDGET_NORMAL_BUTTON, Wlevely,
			 EZ_WIDTH, 20,
			 EZ_HEIGHT, 20,
			 EZ_LABEL_STRING, "+",
			 EZ_CALLBACK,  LevelPlus, NULL,
			 EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			 EZ_BACKGROUND, "grey74",    
			 EZ_BORDER_WIDTH, 3,
			 0);
  if(level==levelmax){ EZ_DisableWidget(Plus); displus=1; }

  
  Tahy  =  EZ_CreateWidget(EZ_WIDGET_LABEL, VTahy,
			   EZ_FOREGROUND, "white",
			   EZ_LABEL_STRING, "Tahu 0",
			   EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			   0);

  TUndo = EZ_CreateWidget(EZ_WIDGET_NORMAL_BUTTON, VTahy,
			  EZ_WIDTH, 60,
			  EZ_HEIGHT, 21,
			  EZ_LABEL_STRING, "undo",
			  EZ_CALLBACK,  Undo, NULL,
			  EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			  EZ_BACKGROUND, "grey74",    
			  EZ_BORDER_WIDTH, 3,
			  EZ_UNDERLINE, 0,
			  0);
  EZ_DisableWidget(TUndo);

  /*Tnastaveni = EZ_CreateWidget(EZ_WIDGET_NORMAL_BUTTON, RamTlacitek,
			       EZ_WIDTH, 128,		
			       EZ_LABEL_STRING, "Nastaveni",
			       EZ_CALLBACK,  Nastav, NULL,
			       EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			       EZ_BACKGROUND, "white",    
			       EZ_BORDER_WIDTH, 1,
			       EZ_UNDERLINE, 0,
			       0);
			       */   
  Wplocha = EZ_CreateWidget(EZ_WIDGET_FRAME, Whlavni,
			    EZ_WIDTH, 610,
			    EZ_HEIGHT, 600,
			    EZ_PADX, 0,
			    EZ_PADY, 50,
			    EZ_BG_PIXMAP, pozadi,
			    EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			    0);

  EZ_DisplayWidget(Whlavni);

  timer = NULL;
  nic = (struct lod *) malloc (sizeof(struct lod));
  nic->x = 0; nic->y = 0; nic->typ = SPECIAL; nic->w = NULL;
  voda = (struct lod *) malloc (sizeof(struct lod));
  voda->x = 0; voda->y = 0; voda->typ = SPECIAL; voda->w = NULL;
  cil = (struct lod *) malloc (sizeof(struct lod));
  cil->x = 0; cil->y = 0; cil->typ = SPECIAL; cil->w = NULL;
}


void kreslilod (struct lod * l, int jak)
/***************************************/
     /* tupe premisti nebo vyrobi desku */
{
  switch (jak) {
  case VYTVOR:
    l->w = EZ_CreateWidget(EZ_WIDGET_LABEL, Wplocha,
			   EZ_X, l->x*pixelx + l->y*sklon,
			   EZ_Y, l->y*pixely + PROSTOR,	
			   EZ_TRANSIENT, 1,
			   EZ_SHAPED_WINDOW, 1,
			   EZ_PROPAGATE,0,
			   EZ_PADX, 0,
			   EZ_PADY, 0,
			   EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			   EZ_BUBBLE_HELP, "  Bez pohybu tohoto se \n do cile nedostanes", 
			   EZ_LABEL_PIXMAP, pic_lod[(int)(l->typ)],
			   EZ_CLIENT_INT_DATA, LOD,
			   0);
    break;
  case POSUN:
    EZ_ConfigureWidget(l->w, EZ_X, l->x*pixelx + l->y*sklon,
		       EZ_Y, l->y*pixely + PROSTOR, 0);
    break;
  }
}

void kreslidiru (int x, int y)
/****************************************/
     /* vyrobi propast */
{
  if(smer == 0){
    EZ_CreateWidget(EZ_WIDGET_LABEL, Wplocha,
		    EZ_X, x*pixelx + y*sklon ,
		    EZ_Y, y*pixely + PROSTOR ,
		    EZ_TRANSIENT, 1,
		    EZ_SHAPED_WINDOW, 1,
		    EZ_PROPAGATE,0,
		    EZ_PADX, 0,
		    EZ_PADY, 0,
		    EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
		    EZ_LABEL_PIXMAP, dira,
		    0);
  }
  else{
    EZ_CreateWidget(EZ_WIDGET_LABEL, Wplocha,
		    EZ_X, x*pixelx + y*sklon ,
		    EZ_Y, y*pixely + PROSTOR ,
		    EZ_HEIGHT, STRANA,
		    EZ_WIDTH, STRANA,
		    EZ_TRANSIENT, 1,
		    EZ_SHAPED_WINDOW, 1,
		    EZ_PROPAGATE,0,
		    EZ_PADX, 0,
		    EZ_PADY, 0,
		    EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
		    EZ_BACKGROUND, "DarkSlateGray",
		    0);
  }
}


void kreslipanaka (int jak)
/*************************/
     /* tupe premisti nebo vyrobi figurku */
{
  switch (jak) {
  case VYTVOR:
    Wpanacek = EZ_CreateWidget(EZ_WIDGET_LABEL, Wplocha,
			       EZ_X, px*pixelx + py*sklon + panakx,
			       EZ_Y, py*pixely + PROSTOR + panaky,	
			       EZ_TRANSIENT, 1,
			       EZ_SHAPED_WINDOW, 1,
			       EZ_PROPAGATE,0,
			       EZ_PADX, 0,
			       EZ_PADY, 0,
			       EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			       EZ_BUBBLE_HELP, "To jsi ty",
			       EZ_LABEL_PIXMAP, pic_panak, 
			       EZ_CLIENT_INT_DATA, PANAK,
			       0);
    EZ_DisplayWidget(Wplocha);
    break;
  case POSUN:
    EZ_ConfigureWidget(Wpanacek, EZ_X, px*pixelx + py*sklon + panakx,
		       EZ_Y, py*pixely + PROSTOR + panaky, 0);
    break;
  }
}

void Vyres(EZ_Widget *widget)
     /* rozhodne co udelat s widgetem (na konci animace) */ 
/*****************************/
{
  FILE* file;
  int TypWidget, x, y, stihnul;
  
  TypWidget = EZ_GetWidgetIntData(widget);
  
  timer = NULL;

  switch(TypWidget){
  
  case KONEC: 
    Restartuj();
    break;
  case PANAK: 
    kreslipanaka(POSUN);

    if(vicetah == -2)
    {
      vicetah = -1;
      break;
    }

    if(deska[px][py]==cil && edit == 0) {
      level++;
      EZ_EnableWidget(Minus);
      disminus=0;
      if(level>levelmax && level>-levelmax){
	sprintf (fnbuffer, "%s/%s", getenv("HOME"), LEVELFILE);
	file = fopen(fnbuffer,"w");
	if (file != NULL) {
	  fwrite(&level,sizeof(int),1,file);
	  fclose(file);
	}
	levelmax = level;
      }
      deska[px][py] = voda;
      Dostan(Wostrov, px*pixelx + py*sklon, -70);
      break;
    }
    if(deska[px][py]->typ == SUPERLOD){
      if(deska [deska[px][py]->x] [deska[px][py]->y]  !=  voda) break;

      x = px;
      y = py;

      sprintf(fnbuffer,"dostanu te na \n %d. radek a \n %d. sloupec", y+1, x+1);
      EZ_ConfigureWidget(deska[x][y]->w, EZ_BUBBLE_HELP, fnbuffer, 0);


      px = deska[x][y]->x;
      py = deska[x][y]->y;
      
      Dostan(deska[x][y]->w, px*pixelx + py*sklon, py*pixely + PROSTOR);

      deska[px][py] = deska[x][y];
      deska[x][y] = voda;

      deska[px][py]->x = x;
      deska[px][py]->y = y;
    }
    break;

  case TELEPORT:
    if(vicetah > -1)
    {
      if(vicetah == 0){py = py+1;}
      if(vicetah == 1){py = py-1;}
      if(vicetah == 2){px = px+1;}
      if(vicetah == 3){px = px-1;}

      vicetah = -2;

      if (animace == 2) stihnul = 0;
      else stihnul = 1;

      if (stihnul) animace++;
      Dostan(Wpanacek, px*pixelx + py*sklon + panakx,
	     py*pixely + PROSTOR + panaky);
      if (stihnul) animace--;
    }
    break;

  case LOD: 
    kreslipanaka(POSUN);
    kreslilod(deska[px][py], POSUN);
    if(deska[px][py]->typ == LODH)
    break;
  }
}

static void Jedem(EZ_Timer *timer, EZ_Widget *widget)
     /* posune o kousek libovolny widget (uprostred animace) */
/**********************************************/
{
  tolikrat++;

  /* printf ("tolikrat=%d, zX=%d, zY=%d\n", tolikrat, zX, zY); */
  EZ_ConfigureWidget(widget, EZ_X, zX - meziX*tolikrat/kolikrat,
		             EZ_Y, zY - meziY*tolikrat/kolikrat, 0);
  if (EZ_GetWidgetIntData(widget) != PANAK) 
    EZ_ConfigureWidget(Wpanacek, EZ_X, zX - meziX*tolikrat/kolikrat + kuX,
		       EZ_Y, zY - meziY*tolikrat/kolikrat + kuY, 0);
  if(tolikrat >= kolikrat) Vyres(widget);
}

EZ_Widget* Obnov(EZ_Widget *widget)
     /* dostane widget do popredi */
/**********************************/
{
  int TypWidget, x, y;

  TypWidget = EZ_GetWidgetIntData(widget);
  EZ_GetWidgetPosition (widget, &x, &y);

  EZ_DestroyWidget(widget);

  switch(TypWidget)
    {
    case KONEC:  
      if(smer==0){
      widget = EZ_CreateWidget(EZ_WIDGET_LABEL, Wplocha,
			       EZ_X, x,
			       EZ_Y, y,
			       EZ_TRANSIENT, 1,
			       EZ_SHAPED_WINDOW, 1,
			       EZ_PROPAGATE,0,
			       EZ_PADX, 0,
			       EZ_PADY, 0,
			       EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			       EZ_LABEL_PIXMAP, modre,
			       EZ_BACKGROUND, "blue",
			       EZ_CLIENT_INT_DATA, KONEC,
			       0);
      }
      else{
	widget = EZ_CreateWidget(EZ_WIDGET_LABEL, Wplocha,
				  EZ_X, x,
				  EZ_Y, y,
				  EZ_TRANSIENT, 1,
				  EZ_SHAPED_WINDOW, 1,
				  EZ_PROPAGATE,0,
				  EZ_PADX, 0,
				  EZ_PADY, 0,
				  EZ_WIDTH, STRANA,
				  EZ_HEIGHT, STRANA,
				  EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
				  EZ_BACKGROUND, "blue",
				  EZ_CLIENT_INT_DATA, 2,
				  0);
      }
      break;
    case PANAK:
      widget = EZ_CreateWidget(EZ_WIDGET_FREE_LABEL, Wplocha,
			       EZ_X, x,
			       EZ_Y, y,
			       EZ_TRANSIENT, 1,
			       EZ_SHAPED_WINDOW, 1,
			       EZ_PROPAGATE,0,
			       EZ_PADX, 0,
			       EZ_PADY, 0,
			       EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			       EZ_LABEL_PIXMAP, pic_panak,
			       EZ_CLIENT_INT_DATA, PANAK,
			       0);
      break;
  }
  EZ_DisplayWidget(Wplocha);
  return widget;
}

void Dostan(EZ_Widget *widget, int doX, int doY)
     /* zalozi timer (na zacatku animace) */
/**********************************************/
{
 int vetsi, TypWidget;

 if (timer!=NULL)return;

 TypWidget = EZ_GetWidgetIntData(widget);

 /* printf ("TypWidget = %d\n",TypWidget); */

 if (TypWidget != PANAK && TypWidget != LOD && TypWidget != TELEPORT) {
   widget = Obnov(widget);
   Wpanacek = Obnov(Wpanacek);
 }

 EZ_GetWidgetPosition (widget, &zX, &zY);
 if (TypWidget != PANAK) {
   EZ_GetWidgetPosition (Wpanacek, &kuX, &kuY);
   kuX = kuX - zX;
   kuY = kuY - zY;
 }
 /* printf ("animace: %d, %d\n", animace, TypWidget); */
 if(animace==1)if(TypWidget==PANAK || TypWidget==LOD){
   Vyres(widget);
   return;
 }
 if(animace==2){
   EZ_ConfigureWidget(widget,EZ_X, doX, EZ_Y, doY, 0);
   if(TypWidget!=PANAK)
     EZ_ConfigureWidget(Wpanacek,EZ_X, doX + kuX, EZ_Y, doY + kuY, 0);
   Vyres(widget);
   return;
 }

 meziX = zX - doX;
 meziY = zY - doY;
 
 if(meziX > 0) vetsi = meziX;
 else vetsi = -meziX;

 if(meziY > vetsi) vetsi = meziY;
 else if(-meziY > vetsi) vetsi = -meziY;

 tolikrat = 0;
 kolikrat = vetsi/7;

 /* printf("zakladam timer\n"); */

 timer = EZ_CreateTimer (0, 50000, kolikrat, Jedem, widget, 0);
}

void posunlod (struct lod * l, int kam) 
     /* posune desku */
/**************************************/
{
  switch (kam) {
  case NAHORU: 
    if (l->typ==LODH) break;
    if (l->y <= 0) break;
    deska [l->x][l->y + 1] = voda;
    deska [l->x][l->y - 1]  = l;
    (l->y)--;
    break;
  case DOLU:
    if (l->typ==LODH) break;
    if (l->y + 1 >= ymax) break;
    deska [l->x][l->y] = voda;
    deska [l->x][l->y + 2]  = l;
    (l->y)++;
    break;
  case DOLEVA:
    if (l->typ==LODV) break;
    if (l->x <= 0) break;
    deska [l->x + 1][l->y] = voda;
    deska [l->x - 1][l->y]  = l;
    (l->x)--;
    break;
  case DOPRAVA:
    if (l->typ==LODV) break;
    if (l->x + 1 >= xmax) break;
    deska [l->x][l->y] = voda;
    deska [l->x + 2][l->y]  = l;
    (l->x)++;
    break;
    }
}

void printdeska (void)
     /* ladici funkce, vypise obsah desky */
/********************/
{
  int i, j;

  printf ("xmax=%d, ymax=%d, px=%d, py=%d\n", xmax, ymax, px, py);
  for (j=0; j<=ymax; j++) {
     for (i=0; i<=xmax; i++) {
        if (deska [i][j] == voda) printf (".");
	else if (deska [i][j] == nic) printf ("N");
	else if (deska [i][j] == cil) printf ("C");
	else if (deska [i][j]->typ == LODV) printf ("|");
	else if (deska [i][j]->typ == LODH) printf ("-");
	else if (deska [i][j]->typ == OSTROV) printf ("o");
	else printf ("X");
     }
     printf ("\n");
  }
  printf ("\n");
}


void posunpanaka (kam)
     /* posune figurku */
/********************/
{
  if (pocettahu == maxtahu) return;
  if (timer != NULL) return;
  if (deska [px][py] == voda) return;

  switch (kam) {    
  case NAHORU:
    if (py <= 0) break;
    if (deska[px][py-1] == nic) break;
    if (deska[px][py-1] == voda) {
      if (deska [px][py]->typ!=LODV) break;
      posunlod(deska [px][py], NAHORU);
      py--;
      UlozInfo(4);
      Dostan(deska [px][py]->w,px*pixelx + py*sklon,
	                       py*pixely + PROSTOR);
      VyresTahy();
      return;
    }
    py--;
    UlozInfo(0);
    Dostan(Wpanacek,px*pixelx + py*sklon + panakx,
	            py*pixely + PROSTOR + panaky);
    VyresTahy();
    break;
  case DOLU:
    if (py >= ymax) break;
    if (deska[px][py+1] == nic) break;
    if (deska[px][py+1] == voda) {
      if (deska [px][py]->typ!=LODV) break;
      posunlod(deska [px][py], DOLU);
      py++;
      UlozInfo(5);
      Dostan(deska [px][py]->w,px*pixelx + (py-1)*sklon,
	                       (py-1)*pixely + PROSTOR);
      VyresTahy();
      return;
    }
    py++;
    UlozInfo(1);
    Dostan(Wpanacek,px*pixelx + py*sklon + panakx,
	            py*pixely + PROSTOR + panaky);
    VyresTahy();
    break;
  case DOLEVA:
    if (px <= 0) break;
    if (deska[px-1][py] == nic) break;
    if (deska[px-1][py] == voda) {
      if (deska [px][py]->typ!=LODH) break;
      posunlod(deska [px][py], DOLEVA);
      px--;
      UlozInfo(6);
      Dostan(deska [px][py]->w,px*pixelx + py*sklon,
	                       py*pixely + PROSTOR);
      VyresTahy();
      return;
    }
    px--;
    UlozInfo(2);
    Dostan(Wpanacek,px*pixelx + py*sklon + panakx,
	            py*pixely + PROSTOR + panaky);
    VyresTahy();
    break;
  case DOPRAVA:
    if (px >= xmax) break;
    if (deska[px+1][py] == nic) break;
    if (deska[px+1][py] == voda) {
      if (deska [px][py]->typ!=LODH) break;
      posunlod(deska [px][py], DOPRAVA);
      px++;
      UlozInfo(7);
      Dostan(deska [px][py]->w,(px-1)*pixelx + py*sklon,
	                       py*pixely + PROSTOR);
      VyresTahy();
      return;
    }
    px++;
    UlozInfo(3);
    Dostan(Wpanacek,px*pixelx + py*sklon + panakx,
	            py*pixely + PROSTOR + panaky);
    VyresTahy();
    break;
  }    
}

void VytvorTeleport()
     /* vyrobi zluty ostuvek */
/*******************/
{
  struct lod * l;
  
  sprintf(fnbuffer,"dostanu te na \n %d. radek a \n %d. sloupec",teleport[3]+1, teleport[2]+1);

  l = (struct lod *) malloc (sizeof(struct lod));
  deska[teleport[0]][teleport[1]] = l;
  if(smer == 0){
  deska[teleport[0]][teleport[1]]->w = EZ_CreateWidget(EZ_WIDGET_LABEL, Wplocha,
						       EZ_X, teleport[0]*pixelx + teleport[1]*sklon ,
						       EZ_Y, teleport[1]*pixely + PROSTOR ,
						       EZ_TRANSIENT, 1,
						       EZ_SHAPED_WINDOW, 1,
						       EZ_PROPAGATE,0,
						       EZ_PADX, 0,
						       EZ_PADY, 0, 
						       EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
						       EZ_LABEL_PIXMAP, zlute, 
						       EZ_BUBBLE_HELP, fnbuffer,
						       EZ_CLIENT_INT_DATA, TELEPORT,
						       0);
  }
  else{
    deska[teleport[0]][teleport[1]]->w = EZ_CreateWidget(EZ_WIDGET_LABEL, Wplocha,
							 EZ_X, teleport[0]*pixelx + teleport[1]*sklon ,
							 EZ_Y, teleport[1]*pixely + PROSTOR ,
							 EZ_WIDTH, STRANA,
							 EZ_HEIGHT, STRANA,
							 EZ_TRANSIENT, 1,
							 EZ_SHAPED_WINDOW, 1,
							 EZ_PROPAGATE,0,
							 EZ_PADX, 0,
							 EZ_PADY, 0, 
							 EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
							 EZ_BACKGROUND, "yellow",
							 EZ_BUBBLE_HELP, fnbuffer,
							 EZ_CLIENT_INT_DATA, TELEPORT,
							 0);
  }
  deska[teleport[0]] [teleport[1]] -> x = teleport[2];
  deska[teleport[0]] [teleport[1]] -> y = teleport[3];
  deska[teleport[0]] [teleport[1]] -> typ = SUPERLOD;
}
     
void nactilevel()
     /* nacte level */
/***************/
{  
  FILE* file;
  int i, j, ch, udaj;
  struct lod * l;
  char nazev[MAXFILENAME];

  pocettahu = 0;
  EZ_ConfigureWidget (Tahy, EZ_LABEL_STRING, "0 tahu", 0);

  for (i=0; i<MAXDESKA; i++)  for (j=0; j<MAXDESKA; j++) deska [i][j] = nic;
  maxtahu = i = j = xmax = ymax = 0;

  sprintf (nazev, "xdesky.l%d", level);
  file = fopen (nazev, "r");
  if (file == NULL) {
    file = fopen (filename(nazev), "r");
    if (file == NULL) {
      if (level==1){
	fprintf (stderr, "nacitam soubor: %s\n", filename(nazev));
	error ("nelze otevrit soubor ke cteni levelu");  
      }
      EZ_EnableWidget(Plus);
      displus=0;

      if(levelmax>0) levelmax = -levelmax+1;
      level=1;
      nactilevel();
      return;
    }
  }
  sprintf (nazev, "level: %d", level);  
  EZ_ConfigureWidget (LevelNapis, EZ_LABEL_STRING, nazev, 0);

  ch = fgetc (file);

  while (ch != EOF) {
    if (ch == '\n') {
      if(xmax<i-1) xmax = i-1;
      ch = fgetc (file);
      if (ch == EOF || ch == '\n') break;
      i = 0;
      j++;
      ymax = j;
    }
    if(ch!=' ' && ch!='m') kreslidiru (i, j);
    i++;
    ch = fgetc (file);
  }
  if(xmax<i-1) xmax = i-1;

  i = j = 0;
  fseek (file, 0, SEEK_SET);
  ch = fgetc (file);

  while (ch != EOF) {
    if (ch == '\n') {
      ch = fgetc (file);
      if (ch == EOF || ch == '\n') break ;
      i = 0;
      j++;
    }
    switch (ch) {
    case '<': 
      if (i+1>=MAXDESKA) error ("i je moc velke");
      l = (struct lod *) malloc (sizeof(struct lod));
      deska[i+1][j] = deska[i][j] = l;
      l->x = i;
      l->y = j;
      l->typ = LODH;
      kreslilod (l, VYTVOR);
      break;
    case 'm':
      if(smer == 0){
      Wostrov = EZ_CreateWidget(EZ_WIDGET_LABEL, Wplocha,
				EZ_X, i*pixelx + j*sklon,
				EZ_Y, j*pixely + PROSTOR ,
				EZ_TRANSIENT, 1,
				EZ_SHAPED_WINDOW, 1,
				EZ_PROPAGATE,0,
				EZ_PADX, 0,
				EZ_PADY, 0,
				EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
				EZ_BUBBLE_HELP, "Sem se musis\n  dostat",
				EZ_LABEL_PIXMAP, modre,
				EZ_CLIENT_INT_DATA, 2,
				0);
      }
      else{
	Wostrov = EZ_CreateWidget(EZ_WIDGET_LABEL, Wplocha,
				  EZ_X, i*pixelx + j*sklon,
				  EZ_Y, j*pixely + PROSTOR ,
				  EZ_TRANSIENT, 1,
				  EZ_SHAPED_WINDOW, 1,
				  EZ_PROPAGATE,0,
				  EZ_PADX, 0,
				  EZ_PADY, 0,
				  EZ_WIDTH, STRANA,
				  EZ_HEIGHT, STRANA,
				  EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
				  EZ_BUBBLE_HELP, "Sem se musis\n  dostat",
				  EZ_BACKGROUND, "blue",
				  EZ_CLIENT_INT_DATA, 2,
				  0);
      }

      deska[i][j] = cil;
      ostrov=1;
      break;
    case '^':
      l = (struct lod *) malloc (sizeof(struct lod));
      deska[i][j+1] = deska[i][j] = l;
      l->x = i;
      l->y = j;
      l->typ = LODV;
      kreslilod (l, VYTVOR);
      break;
    case 'o':
      l = (struct lod *) malloc (sizeof(struct lod));
      deska[i][j] = l;
      l->x = i;
      l->y = j;
      l->typ = OSTROV;
      if(smer==0){
      l->w = EZ_CreateWidget(EZ_WIDGET_LABEL, Wplocha,
			     EZ_X, i*PIXELX + j*SKLON ,
			     EZ_Y, j*PIXELY + PROSTOR ,
			     EZ_TRANSIENT, 1,
			     EZ_SHAPED_WINDOW, 1,
			     EZ_PROPAGATE,0,
			     EZ_PADX, 0,
			     EZ_PADY, 0,
			     EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			     EZ_BUBBLE_HELP, "   muzes na \n toto vstoupit", 
			     EZ_LABEL_PIXMAP, bostrov,
			     0);
      }
      else{
	l->w = EZ_CreateWidget(EZ_WIDGET_LABEL, Wplocha,
			       EZ_X, i*pixelx + j*sklon,
			       EZ_Y, j*pixely + PROSTOR,
			       EZ_WIDTH, STRANA,
			       EZ_HEIGHT, STRANA,
			       EZ_TRANSIENT, 1,
			       EZ_SHAPED_WINDOW, 1,
			       EZ_PROPAGATE,0,
			       EZ_PADX, 0,
			       EZ_PADY, 0,
			       EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			       EZ_BUBBLE_HELP, "   muzes na \n toto vstoupit", 
			       EZ_BACKGROUND, "white",
			       0);
      }
      break;
    case '.':
      deska[i][j] = voda;
      break;
    }
    ch = fgetc (file);
    i++;
  }
  
  while(ch != EOF){
    ch = fgetc (file);
    if(ch == 'p' || ch == 'P') while(ch != EOF && ch != '\n') {
      ch = fgetc (file);
      if(ch=='x') while(1){
	ch = fgetc (file);
	if(isdigit(ch)){
	  px = px*10;
	  px = px + ch - 48;
	}
	else break;
      }
      if(ch=='y') while(1){
	ch = fgetc (file);
	if(isdigit(ch)){
	  py = py*10;
	  py = py + ch - 48;
	}
	else break;
      }
    }
    if(ch == 't' || ch == 'T') {
      udaj = 0;
      while(udaj <= 3){
	teleport [udaj] = 0;
	udaj++;
      }
      udaj = 0;
      while(ch != EOF && ch != '\n') {
	ch = fgetc (file);
	if(ch=='x') while(1){
	  ch = fgetc (file);
	  if(isdigit(ch)){
	    teleport[udaj] = teleport[udaj]*10;
	    teleport[udaj] = teleport[udaj] + ch - 48;
	  } 
	  else break;
	}  
	if(ch=='y') while(1){
	  ch = fgetc (file);
	  if(isdigit(ch)){
	    teleport[udaj+1] = teleport[udaj+1]*10;
	    teleport[udaj+1] = teleport[udaj+1] + ch - 48;
	  } 
	  else break;
	}
	if(ch=='-'){
	  ch = fgetc (file);
	  if(ch=='-') udaj=2;
	}
      }
      VytvorTeleport();
    }
    if(ch == 'm' || ch == 'M') {
      while(ch != EOF && ch != '\n') {
	ch = fgetc (file);
	if(ch=='p'){ 
	  while(1){
	    ch = fgetc (file);
	    if(isdigit(ch)){
	      maxtahu=maxtahu*10;
	      maxtahu = maxtahu + ch - 48;
	    }else break;
	  }
	  sprintf(nazev,"neprekrocit: %d tahu",maxtahu);
	  if(WMaxtahy==NULL){
	    WMaxtahy  =  EZ_CreateWidget(EZ_WIDGET_LABEL, VTahy,
					 EZ_FOREGROUND, "white",
					 EZ_LABEL_STRING, nazev,
					 EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
					 0);
	  }else{
	    EZ_ConfigureWidget(WMaxtahy, EZ_LABEL_STRING, nazev,0);
	  }
	}
      }
    }    
  }
  if(maxtahu==0){
    maxtahu=-1;
    if(WMaxtahy!=NULL){
      EZ_DestroyWidget(WMaxtahy);
      WMaxtahy = NULL;
    }
  }
  fclose (file);
}
void Edit()
     /* nepouzita funkce */
/*********/
{
  int i, j;

  edit=1;

  px = py = 0;
  /* printf("ta\n"); */
  if(timer!=NULL){ 
    EZ_CancelTimer(timer);
    timer=NULL;
  }

  if(smer == 0) ZmenPohled();
  /* printf("to\n"); */
  EZ_DestroyWidget(Wplocha); 
  Wplocha = EZ_CreateWidget(EZ_WIDGET_FRAME, Whlavni,
			    EZ_WIDTH, 610,
			    EZ_HEIGHT, 600,
			    EZ_PROPAGATE, 1,
			    EZ_PADX, 0,
			    EZ_PADY, 0,
			    EZ_BG_PIXMAP, pozadi,
			    EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			    0);
  px=0;
  py=0;
  for (i=0; i<MAXDESKA; i++)  for (j=0; j<MAXDESKA; j++) deska [i][j] = nic;

  Wostrov = EZ_CreateWidget(EZ_WIDGET_FREE_LABEL, Wplocha,
			    EZ_X, STRANA,
			    EZ_Y, 0,
			    EZ_WIDTH, STRANA,
			    EZ_HEIGHT, STRANA,
			    EZ_TRANSIENT, 1,
			    EZ_SHAPED_WINDOW, 1,
			    EZ_FREELABEL_MOVABLE,1,
			    EZ_PROPAGATE,0,
			    EZ_PADX, 0,
			    EZ_PADY, 0,
			    EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			    EZ_BACKGROUND, "blue",
			    0);

  /* printf("tu\n"); */
  Wpanacek = EZ_CreateWidget(EZ_WIDGET_FREE_LABEL, Wplocha,
			     EZ_X, 0,
			     EZ_Y, 0,
			     EZ_TRANSIENT, 1,
			     EZ_SHAPED_WINDOW, 1,
			     EZ_FREELABEL_MOVABLE,1,
			     EZ_PROPAGATE,0,
			     EZ_PADX, 0,
			     EZ_PADY, 0,
			     EZ_CLIENT_INT_DATA, PANAK,
			     EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
			     EZ_LABEL_PIXMAP, pic_panak,
			     0);
  /* printf("tady\n"); */
  EZ_DisplayWidget(Wplocha);
}

void CoDelatPriKlavese (EZ_Widget *widget, void *data, int etype, XEvent *xeve)
     /* radic udalosti */
/*****************************************************************************/
{
  int x, y, dx, dy;

  if (etype==EZ_KEY_PRESS) {
    switch (EZ_PressedKey) {
    case EZ_UP_KEY:
      posunpanaka (NAHORU);
      break;
    case EZ_DOWN_KEY:
      posunpanaka (DOLU);
      break;
    case EZ_LEFT_KEY:
      posunpanaka (DOLEVA);
      break;
    case EZ_RIGHT_KEY:
      posunpanaka (DOPRAVA);
      break;
    case 'q':
    case 'Q':
      Konci();
    case 'r':
    case 'R':
      Restartuj();
      break;
    case 'z':
    case 'Z':
      ZmenPohled();
      break;
    case '=':
    case '+':
      LevelPlus();
      break;
    case '_':
    case '-':
      LevelMinus();
      break;
    case 'N':
    case 'n':
      Napovez();
      break;
    case 'A':
    case 'a':
      Animace();
      break;
    case 'U':
    case 'u': 
      Undo();
      break;
    }
  }
  if(etype==EZ_BUTTON1_RELEASE && WBlik != NULL){ EZ_DestroyWidget(WBlik); WBlik = NULL; }

  /* printf("edit = %d\n", edit); */

  if(etype==EZ_BUTTON1_PRESS) {
    /* printf("odchytnul\n"); */
    EZ_GetWidgetPosition(widget, &x, &y );
    /* printf("%d\n",smer); */
    if(smer==0){
      dy=(y-PROSTOR)/PIXELY;
      dx=(x-dy*SKLON)/PIXELX;
      /* printf("%d, %d\n", x, y);
      printf("%d, %d\n", dx, dy); */
      x=dx;
      y=dy;
      /* printf("%d,%d\n",x,y); */
      if(x<0 || y<0) return;
      /* printf("%d\n",deska[x][y]->typ); */
      if(deska[x][y]->typ == SUPERLOD && EZ_GetWidgetIntData(widget)==TELEPORT){
	/* printf("3\n"); */
	dx=deska[x][y]->x;
	dy=deska[x][y]->y;
	/* printf("%d, %d, %d, %d\n", dx, dy, dx*PIXELX+dy*SKLON, dy*PIXELY+PROSTOR); */
	WBlik = EZ_CreateWidget(EZ_WIDGET_LABEL, Wplocha,
				EZ_X, dx*PIXELX+dy*SKLON,
				EZ_Y, dy*PIXELY+PROSTOR,
				EZ_TRANSIENT, 1,
				EZ_SHAPED_WINDOW, 1,
				EZ_PROPAGATE,0,
				EZ_PADX, 0,
				EZ_PADY, 0, 
				EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
				EZ_LABEL_PIXMAP,  cerveno,
				0);
	EZ_DisplayWidget(Wplocha);
        /* printf ("OK\n"); */
      }
    }else{    
      x=x/STRANA;
      y=(y-PROSTOR)/STRANA;
      /* printf("%d, %d\n", x, y); */
      if(x<0 || y<0)return;
      /* printf("%d\n",deska[x][y]->typ); */
      if(deska[x][y] -> typ == SUPERLOD && EZ_GetWidgetIntData(widget)==TELEPORT){
	dx=deska[x][y]->x;
	dy=deska[x][y]->y;
	WBlik = EZ_CreateWidget(EZ_WIDGET_LABEL, Wplocha,
				EZ_X, dx*STRANA,
				EZ_Y, dy*STRANA+PROSTOR,
				EZ_WIDTH, STRANA,
				EZ_HEIGHT, STRANA,
				EZ_TRANSIENT, 1,
				EZ_SHAPED_WINDOW, 1,
				EZ_PROPAGATE,0,
				EZ_PADX, 0,
				EZ_PADY, 0, 
				EZ_EVENT_HANDLER, CoDelatPriKlavese, NULL,
				EZ_BACKGROUND, "red",
				0);
	EZ_DisplayWidget(Wplocha);
      }
    }      
  }  
  /* printf("edit = %d\n", edit); */

  if(etype==EZ_BUTTON1_PRESS && edit == 1) {
    EZ_GetWidgetPosition(widget, &x, &y );
    minx = x;
    miny = y;
  }
  
  /*printf("edit = %d\n", edit); */
  
  if(etype==EZ_BUTTON1_RELEASE && edit == 1) {
    /* printf("etype==EZ_BUTTON1_RELEASE\n"); */
    
    EZ_GetWidgetPosition(widget, &x, &y );
    if (widget==Wpanacek){
      /* printf("widget==Wpanacek\n"); */
      
      if(x < -STRANA/2 || y < -STRANA/2){
	x = px*STRANA;
	y = py*STRANA;
	    
	/* printf("px %d, py %d\n", px, py); */
      }
	  
      px = x;
      py = y;
      
      px = (px + STRANA/2) / STRANA;
      py = (py + STRANA/2) / STRANA;
	  
      /* printf("px %d, py %d\n", px, py); */
	  
      EZ_ConfigureWidget(Wpanacek, EZ_X, px*STRANA, EZ_Y, py*STRANA, 0);
    }
    if (widget==Wostrov){
      /* printf("widget==Wpanacek\n"); */
	  
      if(x < -STRANA/2 || y < -STRANA/2){
	x = minx;
	y = miny;
	
	/* printf("px %d, py %d\n", px, py); */
      }
      
      x = (x + STRANA/2) / STRANA;
      y = (y + STRANA/2) / STRANA;
      
      
      deska[minx][miny] = voda;
      deska[x][y] = cil;
      
      /* printf("x %d, y %d\n",x, y); */
      
      EZ_ConfigureWidget(Wostrov, EZ_X, x*STRANA, EZ_Y, y*STRANA, 0);
    }
  }
}

int main (int argc, char **argv) 
/******************************/
{

  int ks, kzs;

  edit=0;
  smer=1;
  level=0;
  animace=1;
  vicetah=-1;

  EZ_Initialize (argc, argv, 0);

  sprintf(datadir,"%s", DATADIR);

  ks = 1;

  while(1)
  {
    if (ks == argc) break;
    if(strcmp("-d",argv[ks]) == 0 || strcmp("-data",argv[ks]) == 0)
    {
      ks++;
      if (ks == argc) break;
      else
      {
	kzs = 0;
	while(argv[ks][kzs] != 0)
	{
	  datadir[kzs] = argv[ks][kzs];
	  kzs++;
	}
	datadir[kzs] = 0;
      }
    } 
    if(strcmp("-l",argv[ks]) == 0 || strcmp("-level",argv[ks]) == 0)
    {
      ks++;
      if (ks == argc) break;
      else
      {
	level = atoi(argv[ks]);
      }
    } 
    if(strcmp("-a",argv[ks])==0 || strcmp("-animace",argv[ks])==0) animace = 0;
    if(strcmp("-p",argv[ks])==0 || strcmp("-pohled",argv[ks])==0) smer = 0;
    if(strcmp("-h",argv[ks])==0 || strcmp("-help",argv[ks])==0) {
      printf("\
pouziti: xdesky [-a|-animace] [-p|-pohled] [{-d|-data} adresar]\n\
   -a, -animace      : zapnuta animace\n\
   -p, -pohled       : pohled zsikma\n\
   -d, -data adresar : adresar s obrazky, inplicitne %s\n\
   -l, -level cislo  : cislo levelu, inplicitne posledni nedohrany\n\
                       level
", DATADIR);
      return 1;
    }
    ks++;
  }
  WMaxtahy=NULL;

  inicializujplochu ();

  pocetnapoved=0;
  konec=-1;
  px = py = 0;
  nactilevel ();
  kreslipanaka (VYTVOR);

  EZ_EventMainLoop();
  return 0;
}
